//date11-10-51
//code by wink99_th
//Modify OutThai code from  my friend "Khun NewBiz" at webboard www.thainin.com

#include <nds.h>
#include<string.h>

#include "ThaiFont.dat"		
#include "FF13_1.h"
#include "FF13_2.h"

//Music Libary : ASLib
#include "as_lib9.h"

// the sounds
#include "test_mp3.h"


u16 *   bg0MapMemory =(u16*)BG_MAP_RAM_SUB(0); 
u16 *   bg0TileData =(u16*)BG_TILE_RAM_SUB(2); 

// ¹ش Шش
void PutPixel(int screenPosX, int screenPosY, unsigned short int color) 
{ 
   int tileX,tileY,interiorX,interiorY,AddressM; 
   u16 originalColor;
   tileX = screenPosX/8; // figure out the "column" we're writing to 
   tileY = screenPosY/8; // figure out the "row" 
   interiorX = screenPosX - tileX*8; // figure our X offset within the tile 
   interiorY = screenPosY - tileY*8; // figure our Y offset withing the tile 

   // ҵ˹觢ͧ TileData ͧ¹
AddressM = (tileY*16*32) + (tileX*16) +( interiorY*2); 

if (interiorX <4)
{
	if (interiorX == 0  )
{originalColor = bg0TileData[AddressM]; 
	bg0TileData[AddressM] = (originalColor & 0xFFF0) + color; 

}
else if (interiorX == 1)
{originalColor = bg0TileData[AddressM]; 
	bg0TileData[AddressM] =  (originalColor & 0xFF0F) + (color<<4); 

}

else if (interiorX == 2)
{
	originalColor = bg0TileData[AddressM]; 
	bg0TileData[AddressM] =  (originalColor & 0xF0FF) + (color<<8); 
}

else if (interiorX == 3)
{originalColor = bg0TileData[AddressM]; 
   bg0TileData[AddressM] =  (originalColor & 0x0FFF) + (color<<12); 
}
} //end if (interiorX <4)

if (interiorX >=4)
{
AddressM = AddressM +1; // ͧ ա˹ 
if (interiorX==4 )
{originalColor = bg0TileData[AddressM]; 
	bg0TileData[AddressM] = (originalColor & 0xFFF0) + color; 

}
else if (interiorX==5)
{originalColor = bg0TileData[AddressM]; 
	bg0TileData[AddressM] =  (originalColor & 0xFF0F) + (color<<4); 

}

else if (interiorX==6)
{
	originalColor = bg0TileData[AddressM]; 
	bg0TileData[AddressM] =  (originalColor & 0xF0FF) + (color<<8); 
}

else if (interiorX==7)
{originalColor = bg0TileData[AddressM]; 
   bg0TileData[AddressM] =  (originalColor & 0x0FFF) + (color<<12); 
}

} //end if (interiorX >=4)


} 


//¹ѡ÷е
void OutCharXY(unsigned char ch,int x,int y,unsigned short int color)
{
	int k,j;
	
	for(k=0;k<16;k++)
      for(j=0;j<8;j++)
		
	      if  (  ThaiFont[ch][k]   &  (1<<j)  )             PutPixel(x+(8-j),y+k,color);
   
}

int IsNoCol(unsigned char ch){
   switch(ch)
	   {
      //                                                    
      case 209:case 212:case 213:case 214:case 215:case 216:case 217:
      //                                                    
      case 218:case 219:case 231:case 232:case 233:case 234:case 235:
      //            
      case 236:case 237:return 1;
      default : return 0;
       }
}

//Ǩͺз˹
int IsToneMark(unsigned char ch){
    switch(ch)
	{
       //                               
       case 232: case 233: case 234: case 235:
       //   
       case 236:
	   return 1;
      }
    return 0;
}

//Ǩͺк
int IsAbove(unsigned char ch)
{
   switch(ch)
	 {
      //                               
      case 209: case 212: case 213: case 214:
      //                               
      case 215: case 231: case 232: case 233:
      //                               
      case 234: case 235: case 236: case 237:
	 return 1;
      }
   return 0;
 }

//ѡ
void OutThai(unsigned char *text, int x0,int y0,unsigned short int color)
{
	int  i;
	int  dx=0,dy=0;
	int  x=x0, y = y0;
	int counttext=0,countrow=0;
            
	for(i=0; i<strlen(text); i++)
		{
                    if(counttext==37){x=x0; y+=16; counttext=0; countrow++;}
					dx = 9-FontSpace[text[i]];
					x= x-dx;
					if(IsNoCol(text[i])) x=x-9; else counttext++;
					if(IsToneMark(text[i]) && IsAbove(text[i-1]))		dy = 4; 
			
					OutCharXY(text[i], x, y-dy, color);
					dy = 0;
					x=x+9;
					dx=0;
			


		} // end For 

 }//end  OutThai

void initFontBG()
{ 
   //駤 Map Ѻ Font
   int row,col; 
   int tileIndex = 0; 
   for (row=0; row<24; row++) 
      for (col=0; col<32; col++)
	   { 
         bg0MapMemory[row*32 + col] = tileIndex ; 
         tileIndex++; 
        } 
 
   BG_PALETTE_SUB[1] = RGB15(31,0,0);
   BG_PALETTE_SUB[2] = RGB15(0,31,0) ;
   BG_PALETTE_SUB[3] = RGB15(0,0,31) ;
   BG_PALETTE_SUB[4] = RGB15(31,31,0) ;

} 


int main(void)
{


	REG_IPC_FIFO_CR = IPC_FIFO_ENABLE | IPC_FIFO_SEND_CLEAR; //music

	powerON( POWER_LCD | POWER_2D_B );
	irqInit();
//    irqSet(IRQ_VBLANK, UpdateBlend); ͧҡ AsLib µͧmodify Դ˹
    irqSet(IRQ_VBLANK, AS_SoundVBL);    // needed for mp3 streaming

    irqEnable(IRQ_VBLANK);



	videoSetMode(MODE_5_2D | DISPLAY_BG0_ACTIVE|DISPLAY_BG2_ACTIVE| DISPLAY_BG3_ACTIVE);	   //駤 Mode ʴ Main Screen  Mode 5 
	videoSetModeSub(MODE_5_2D |DISPLAY_BG0_ACTIVE);  //駤 Mode ʴ Sub Screen  Mode 5
 
	vramSetBankA(VRAM_A_MAIN_BG_0x06000000); // 駤 Vram ͧ Main Screen
    vramSetBankB(VRAM_B_MAIN_BG_0x06020000); // 駤 Vram ͧ Main Screen
    vramSetBankD(VRAM_D_MAIN_BG_0x06040000); // 駤 Vram ͧ Main Screen


   	vramSetBankC(VRAM_C_SUB_BG_0x06200000);  //  駤 Vram ͧ  Sub Screen

   
   //駤 BackGround 3 ͧ Main Screen
	BACKGROUND.control[0] = BG_32x32 | BG_COLOR_256 | BG_MAP_BASE(0) | BG_TILE_BASE(2)|BG_PRIORITY(0) ;
	
	BACKGROUND.control[2] = BG_BMP16_256x256 | BG_BMP_BASE(5) ;
	BACKGROUND.bg2_rotation.xdy = 0;
	BACKGROUND.bg2_rotation.xdx = 1 << 8;
	BACKGROUND.bg2_rotation.ydx = 0;
	BACKGROUND.bg2_rotation.ydy = 1 << 8;

	BACKGROUND.control[3] = BG_BMP16_256x256 | BG_BMP_BASE(12);
	BACKGROUND.bg3_rotation.xdy = 0;
	BACKGROUND.bg3_rotation.xdx = 1 << 8;
	BACKGROUND.bg3_rotation.ydx = 0;
	BACKGROUND.bg3_rotation.ydy = 1 << 8;
 
	//駤 BackGround 3 ͧ Sub Screen
   BACKGROUND_SUB.control[0] = BG_32x32 | BG_COLOR_16 | BG_MAP_BASE(0) | BG_TILE_BASE(2) | BG_PRIORITY(0); 

	BACKGROUND_SUB.control[3] = BG_BMP16_256x256 | BG_BMP_BASE(5)|BG_PRIORITY(3);
	BACKGROUND_SUB.bg3_rotation.xdy = 0;
	BACKGROUND_SUB.bg3_rotation.xdx = 1 << 8;
	BACKGROUND_SUB.bg3_rotation.ydx = 0;
	BACKGROUND_SUB.bg3_rotation.ydy = 1 << 8;
   
	// Init Font
	initFontBG();

    //Load Ҿ ͧ Main BG
     dmaCopyHalfWords(3, FF13_1Bitmap,  (uint16 *) BG_BMP_RAM(5), FF13_1BitmapLen); // Copy background  Main Screen  
     dmaCopyHalfWords(3, FF13_2Bitmap,  (uint16 *) BG_BMP_RAM(12), FF13_2BitmapLen); // Copy background  Main Screen  

    //Help Message
	OutThai("ͧ",100,100,2);

	// init the ASlib
    AS_Init(AS_MODE_MP3 | AS_MODE_SURROUND | AS_MODE_16CH);
    
    // set default sound settings
    AS_SetDefaultSettings(AS_PCM_8BIT, 11025, AS_SURROUND);



    // Play mp3
    AS_MP3DirectPlay((u8*)test_mp3, (u32)test_mp3_size);
    AS_SetMP3Loop(true);

     BLEND_CR = BLEND_ALPHA | BLEND_SRC_BG2 |BLEND_DST_BG3;

   //Game Loop

   while(1)
	  {
	     swiWaitForVBlank();	
	  }
    
	return 0; 

}



